diff --git a/lib/hive/stages/review.rb b/lib/hive/stages/review.rb
index 7ca0fb20..13edc5bb 100644
--- a/lib/hive/stages/review.rb
+++ b/lib/hive/stages/review.rb
@@ -1,10 +1,13 @@
 require "digest"
 require "fileutils"
+require "json"
 require "open3"
 require "time"
 require "yaml"
 require "hive/events"
+require "hive/claude_completion_fallback"
 require "hive/config"
+require "hive/findings"
 require "hive/protected_files"
 require "hive/claude_launcher"
 require "hive/stages/base"
@@ -67,8 +70,8 @@ module Hive
       # reviewer_sources_for all need to skip these — otherwise a
       # `fix-guardrail-NN.md` user tick `[x]` would re-flow into the
       # next pass's fix prompt and over-amplify guardrail findings.
-      ESCALATION_Q_RE = /^\s*###\s+Q(\d+)\.\s*(.*?)\s*$/.freeze
-      ESCALATION_A_RE = /^\s*###\s+A(\d+)\.\s*$/.freeze
+      ESCALATION_Q_RE = Hive::Stages::Review::Triage::ESCALATION_Q_RE
+      ESCALATION_A_RE = Hive::Stages::Review::Triage::ESCALATION_A_RE
 
       # Per-pass sentinel: `reviews/fix-success-NN.md` is written after
       # a pass's Phase 4 fix succeeds (or Phase 2 produced zero findings
@@ -79,6 +82,8 @@ module Hive
       # Phase 4 with the operator's existing `[x]` marks instead of
       # advancing past them.
       FIX_SUCCESS_FILENAME = "fix-success".freeze
+      FIX_NO_CHANGE_FILENAME = "fix-no-change".freeze
+      FIX_NO_CHANGE_OUTCOME = "no_changes_needed".freeze
       AcceptedFindings = Data.define(:text, :count)
       # Resolved reviewer compare base. `degraded` is true when the
       # configured compare ref did not resolve and we fell back to the
@@ -581,6 +586,11 @@ module Hive
           ]
           before_fix_sha = Hive::ProtectedFiles.snapshot(task.folder, protected_set)
           before_fix_head = git_head(worktree_path)
+          # Stale no-change evidence from a prior retry must not launder
+          # a missing-signal pass. Delete before spawn so only a fresh
+          # agent-authored file can satisfy the no-change gate.
+          clear_fix_no_change_evidence!(ctx_pass)
+          fix_artifact_snapshot = capture_fix_completion_artifacts(ctx_pass)
 
           fix_result = spawn_fix_agent(task, cfg, ctx_pass, accepted: accepted)
           after_fix_sha = Hive::ProtectedFiles.snapshot(task.folder, protected_set)
@@ -594,6 +604,10 @@ module Hive
                      status: :review_error }
           end
 
+          # Hard failures (limit, crash, ordinary timeout without a
+          # provisional completion candidate) stay terminal. A
+          # completion_candidate is provisional and is accepted only
+          # after auto-commit + stage evidence below.
           if agent_failed?(fix_result)
             limited = mark_review_phase_failure(
               task, phase: :fix, terminal_reason: "fix_failed",
@@ -624,6 +638,7 @@ module Hive
             end
 
             after_fix_head = auto_commit[:head]
+            post_fix_status = worktree_status(worktree_path)
           when Array
             Hive::Markers.set(task.state_file, :review_error,
                               phase: :fix, reason: "fix_status_check_failed",
@@ -657,6 +672,31 @@ module Hive
                      status: :review_waiting }
           end
 
+          # Guardrail clearance is part of fallback acceptance. Emitting the
+          # audit before this point would leave a durable success event for a
+          # fix that is subsequently paused as unsafe.
+          if Hive::ClaudeCompletionFallback.completion_candidate?(fix_result)
+            unless accept_fix_completion_fallback(
+              task, ctx_pass, fix_result,
+              before_fix_head: before_fix_head,
+              after_fix_head: after_fix_head,
+              worktree_status: post_fix_status,
+              artifact_snapshot: fix_artifact_snapshot,
+              guardrail_clear: true
+            )
+              # Keep the exact legacy stop-hook message so diagnostics
+              # and the bounded stale-agent healer stay compatible.
+              mark_review_phase_failure(
+                task, phase: :fix, terminal_reason: "fix_failed",
+                pass: pass,
+                error_message: Hive::ClaudeCompletionFallback::STOP_HOOK_ERROR_MESSAGE,
+                limit_text: fix_result && fix_result[:limit_text]
+              )
+              return { commit: "fix_error_pass_#{format('%02d', pass)}",
+                       status: :review_error }
+            end
+          end
+
           # Phase 4 fix succeeded AND guardrail passed: pass N is
           # complete. Drop the sentinel so a subsequent re-entry (e.g.
           # wall-clock fired between this point and the next pass's
@@ -918,6 +958,192 @@ module Hive
         end
       end
 
+      def fix_no_change_path(ctx)
+        File.join(ctx.task_folder, "reviews",
+                  "#{FIX_NO_CHANGE_FILENAME}-#{format('%02d', ctx.pass)}.json")
+      end
+
+      def clear_fix_no_change_evidence!(ctx)
+        path = fix_no_change_path(ctx)
+        File.delete(path) if File.exist?(path)
+      rescue Errno::ENOENT
+        nil
+      end
+
+      # Accept a provisional missing-signal completion only when current-pass
+      # artifacts, commit/no-change proof, worktree health, and escalation
+      # state all pass. Emits one WARN claude_completion_fallback event.
+      # Returns true only when acceptance + audit both succeed.
+      def accept_fix_completion_fallback(task, ctx, fix_result,
+                                          before_fix_head:, after_fix_head:,
+                                          worktree_status:, artifact_snapshot:,
+                                          guardrail_clear:)
+        observation = fix_result && fix_result[:completion_evidence]
+        return false unless observation
+
+        no_change_path = fix_no_change_path(ctx)
+        no_change = parse_fix_no_change_evidence(no_change_path)
+        commit_advanced = before_fix_head.to_s != "" &&
+                          after_fix_head.to_s != "" &&
+                          before_fix_head != after_fix_head
+        commit_or_no_change = commit_advanced || no_change[:present]
+        artifact_facts = fix_completion_artifact_facts(ctx, artifact_snapshot)
+        escalations_path = Hive::Stages::Review::Triage.escalations_path(ctx)
+        evidence = {
+          required_facts: %i[
+            artifacts_present
+            artifacts_fresh
+            artifacts_parseable
+            commit_or_no_change
+            no_unresolved_escalation
+            worktree_readable
+            worktree_clean
+            missing_output_absent
+            protected_files_intact
+            guardrail_clear
+          ],
+          artifacts_present: artifact_facts[:artifacts_present],
+          artifacts_fresh: artifact_facts[:artifacts_fresh],
+          artifacts_parseable: artifact_facts[:artifacts_parseable],
+          commit_or_no_change: commit_or_no_change,
+          no_unresolved_escalation: count_escalations(ctx).zero?,
+          worktree_readable: !worktree_status.is_a?(Array),
+          worktree_clean: worktree_status == :clean,
+          missing_output_absent: artifact_facts[:missing_output_absent],
+          # Tamper was already enforced above; restate so the resolver's
+          # conjunction is self-contained for audit.
+          protected_files_intact: true,
+          guardrail_clear: guardrail_clear == true
+        }
+
+        # A dirty worktree after auto-commit means residue remains; never
+        # accept. A no-change claim with a dirty worktree is also rejected
+        # by worktree_clean == false.
+        commit_evidence =
+          if commit_advanced
+            "commit:#{before_fix_head.to_s[0, 12]}->#{after_fix_head.to_s[0, 12]}"
+          elsif no_change[:present]
+            "no_change:#{File.basename(no_change_path)}"
+          else
+            "none"
+          end
+
+        decision = Hive::Stages::Base.accept_claude_completion_fallback(
+          task: task,
+          stage: stage_label_for(task),
+          agent: "phase=fix pass=#{format('%02d', ctx.pass)}",
+          candidate: fix_result,
+          evidence: evidence,
+          audit_fields: {
+            phase: "fix",
+            pass: format("%02d", ctx.pass),
+            outcome: "fallback_accepted",
+            task_slug: task.slug,
+            artifacts_checked: (
+              Array(artifact_snapshot && artifact_snapshot[:reviewer_files]&.keys).map { |path| File.basename(path) } +
+              [ File.basename(escalations_path.to_s), commit_evidence ]
+            ).join(","),
+            commit_evidence: commit_evidence
+          }
+        )
+
+        unless decision[:accepted]
+          warn "[hive.review] completion fallback rejected for pass " \
+               "#{format('%02d', ctx.pass)}: reason=#{decision[:reason]} " \
+               "missing=#{Array(decision[:missing]).join('|')}"
+          return false
+        end
+
+        true
+      end
+
+      def fix_completion_artifacts_present?(ctx)
+        snapshot = capture_fix_completion_artifacts(ctx)
+        facts = fix_completion_artifact_facts(ctx, snapshot)
+        facts.values.all?
+      end
+
+      def capture_fix_completion_artifacts(ctx)
+        reviewer_files = Hive::Stages::Review::Triage.discover_reviewer_files(ctx)
+        escalations_path = Hive::Stages::Review::Triage.escalations_path(ctx)
+        {
+          pass: ctx.pass,
+          reviewer_files: reviewer_files.to_h { |path| [ path, artifact_identity(path) ] },
+          escalations_path: escalations_path,
+          escalations: artifact_identity(escalations_path)
+        }
+      rescue SystemCallError, IOError
+        nil
+      end
+
+      def fix_completion_artifact_facts(ctx, snapshot)
+        reviewer_files = Hive::Stages::Review::Triage.discover_reviewer_files(ctx)
+        escalations_path = Hive::Stages::Review::Triage.escalations_path(ctx)
+        errors_path = File.join(ctx.task_folder, "reviews",
+                                "errors-#{format('%02d', ctx.pass)}.md")
+        current_reviewers = reviewer_files.to_h { |path| [ path, artifact_identity(path) ] }
+        current_escalations = artifact_identity(escalations_path)
+        expected_reviewers = snapshot && snapshot[:reviewer_files]
+
+        artifacts_present = reviewer_files.any? &&
+                            current_reviewers.values.all? &&
+                            !current_escalations.nil?
+        artifacts_fresh = snapshot.is_a?(Hash) &&
+                          snapshot[:pass] == ctx.pass &&
+                          expected_reviewers.is_a?(Hash) &&
+                          expected_reviewers.any? &&
+                          current_reviewers == expected_reviewers &&
+                          snapshot[:escalations_path] == escalations_path &&
+                          current_escalations == snapshot[:escalations]
+        artifacts_parseable = artifacts_present &&
+                              reviewer_files.all? { |path| Hive::Findings.valid_review_file?(path) } &&
+                              Hive::Stages::Review::Triage.valid_escalations_file?(ctx, escalations_path)
+
+        {
+          artifacts_present: artifacts_present,
+          artifacts_fresh: artifacts_fresh,
+          artifacts_parseable: artifacts_parseable,
+          missing_output_absent: !File.exist?(errors_path)
+        }
+      rescue SystemCallError, IOError
+        {
+          artifacts_present: false,
+          artifacts_fresh: false,
+          artifacts_parseable: false,
+          missing_output_absent: false
+        }
+      end
+
+      def artifact_identity(path)
+        return nil unless File.exist?(path) && File.size(path).positive?
+
+        stat = File.stat(path)
+        {
+          size: stat.size,
+          mtime: [ stat.mtime.to_i, stat.mtime.nsec ],
+          sha256: Digest::SHA256.file(path).hexdigest
+        }
+      rescue SystemCallError, IOError
+        nil
+      end
+
+      # Narrow schema: { "outcome": "no_changes_needed", "rationale": "..." }.
+      # Anything else fails closed.
+      def parse_fix_no_change_evidence(path)
+        return { present: false, rationale: nil } unless File.exist?(path) && File.size(path).positive?
+
+        data = JSON.parse(File.read(path))
+        return { present: false, rationale: nil } unless data.is_a?(Hash)
+        return { present: false, rationale: nil } unless data["outcome"].to_s == FIX_NO_CHANGE_OUTCOME
+
+        rationale = data["rationale"].to_s.strip
+        return { present: false, rationale: nil } if rationale.empty?
+
+        { present: true, rationale: rationale }
+      rescue JSON::ParserError, SystemCallError, IOError
+        { present: false, rationale: nil }
+      end
+
       def limit_failure?(limit_text:, error_message:)
         !limit_text.to_s.empty? || Hive::AgentLimit.from_limit?(error_message.to_s)
       end
@@ -1751,33 +1977,7 @@ module Hive
       end
 
       def parse_escalation_questions(path)
-        return [] unless File.exist?(path)
-
-        questions = []
-        current = nil
-        mode = nil
-
-        File.readlines(path).each do |line|
-          if (match = ESCALATION_Q_RE.match(line))
-            questions << current if current
-            current = {
-              number: match[1].to_i,
-              question: match[2].strip,
-              body: +"",
-              answer: +""
-            }
-            mode = :body
-          elsif current && (match = ESCALATION_A_RE.match(line)) && match[1].to_i == current[:number]
-            mode = :answer
-          elsif current && mode
-            current[mode] << line
-          end
-        end
-
-        questions << current if current
-        questions
-      rescue SystemCallError, IOError
-        []
+        Hive::Stages::Review::Triage.parse_escalation_questions(path)
       end
 
       def write_manual_escalations(ctx)
diff --git a/lib/hive/stages/review/browser_test.rb b/lib/hive/stages/review/browser_test.rb
index e3044913..6c4af754 100644
--- a/lib/hive/stages/review/browser_test.rb
+++ b/lib/hive/stages/review/browser_test.rb
@@ -1,6 +1,7 @@
 require "json"
 require "fileutils"
 require "hive/agent_profiles"
+require "hive/claude_completion_fallback"
 require "hive/claude_launcher"
 require "hive/reviewers/synthetic_task"
 require "hive/stages/base"
@@ -143,6 +144,42 @@ module Hive
               Hive::Stages::Base.spawn_agent(task, **kwargs)
             end
 
+          if Hive::ClaudeCompletionFallback.completion_candidate?(spawn_result)
+            # Presence plus a JSON-object root is not semantic proof: an
+            # empty object (or unknown status) is a malformed browser
+            # artifact. Require the prompt's full result schema before
+            # accepting the missing-signal candidate.
+            if valid_result_file?(result_path)
+              decision = Hive::Stages::Base.accept_claude_completion_fallback(
+                task: task,
+                stage: "6-review",
+                agent: "phase=browser pass=#{format('%02d', ctx.pass)}",
+                candidate: spawn_result,
+                evidence: {
+                  required_facts: %i[artifacts_present missing_output_absent],
+                  artifacts_present: true,
+                  missing_output_absent: true
+                },
+                audit_fields: {
+                  phase: "browser",
+                  pass: format("%02d", ctx.pass),
+                  outcome: "fallback_accepted",
+                  task_slug: File.basename(ctx.task_folder.to_s),
+                  artifacts_checked: File.basename(result_path),
+                  commit_evidence: "n/a"
+                }
+              )
+              return parse_result_file(result_path) if decision[:accepted]
+            end
+            return {
+              status: :failed,
+              summary: "agent spawn failed",
+              details: spawn_result[:error_message].to_s,
+              duration_sec: nil,
+              error_message: spawn_result[:error_message]
+            }
+          end
+
           if spawn_result[:status] != :ok
             return {
               status: :failed,
@@ -156,6 +193,19 @@ module Hive
           parse_result_file(result_path)
         end
 
+        def valid_result_file?(path)
+          return false unless File.exist?(path) && File.size(path).positive?
+
+          parsed = JSON.parse(File.read(path))
+          parsed.is_a?(Hash) &&
+            %w[passed failed].include?(parsed["status"]) &&
+            parsed["summary"].is_a?(String) && !parsed["summary"].strip.empty? &&
+            parsed["details"].is_a?(String) &&
+            parsed["duration_sec"].is_a?(Numeric)
+        rescue JSON::ParserError, SystemCallError, IOError
+          false
+        end
+
         # Read the JSON result file the agent wrote. Tolerates malformed
         # / partial files by treating them as :failed with an explanatory
         # summary — the runner moves to the next attempt either way.
diff --git a/lib/hive/stages/review/ci_fix.rb b/lib/hive/stages/review/ci_fix.rb
index dad72577..b8ff1cc3 100644
--- a/lib/hive/stages/review/ci_fix.rb
+++ b/lib/hive/stages/review/ci_fix.rb
@@ -3,6 +3,7 @@ require "fileutils"
 require "shellwords"
 require "digest"
 require "hive/agent_profiles"
+require "hive/claude_completion_fallback"
 require "hive/claude_launcher"
 require "hive/protected_files"
 require "hive/reviewers/synthetic_task"
@@ -67,6 +68,7 @@ module Hive
 
           attempts = 0
           last_output = nil
+          pending_candidate = nil
 
           loop do
             # DP2: enforce the runner's wall-clock cap between attempts so
@@ -96,13 +98,62 @@ module Hive
             # closed the pipe). Treat nil as non-zero so the loop falls
             # through to the :stale / fix-agent path; only a clean
             # exit-0 counts as :green.
-            return Result.new(
-              status: :green,
-              attempts: attempts,
-              last_output: output,
-              error_message: nil,
-              limit_text: nil
-            ) if run_result.exit_code && run_result.exit_code.zero?
+            if run_result.exit_code && run_result.exit_code.zero?
+              # Accept a provisional missing-signal agent completion only
+              # after CI is green (and the worktree stayed clean).
+              if pending_candidate
+                git_state = candidate_worktree_state(ctx.worktree_path)
+                unless git_state[:state] == :clean
+                  return candidate_worktree_error(
+                    git_state, attempts: attempts, output: output,
+                    limit_text: pending_candidate[:limit_text]
+                  )
+                end
+                decision = Hive::Stages::Base.accept_claude_completion_fallback(
+                  task: synthetic_task(ctx),
+                  stage: "6-review",
+                  agent: "phase=ci_fix attempt=#{format('%02d', attempts)}",
+                  candidate: pending_candidate,
+                  evidence: {
+                    required_facts: %i[
+                      artifacts_present missing_output_absent
+                      worktree_readable worktree_clean
+                    ],
+                    artifacts_present: true,
+                    missing_output_absent: true,
+                    worktree_readable: true,
+                    worktree_clean: true
+                  },
+                  audit_fields: {
+                    phase: "ci_fix",
+                    pass: format("%02d", ctx.pass),
+                    outcome: "fallback_accepted",
+                    task_slug: File.basename(ctx.task_folder.to_s),
+                    artifacts_checked: "ci_exit=0",
+                    commit_evidence: "ci_green"
+                  }
+                )
+                unless decision[:accepted]
+                  return Result.new(
+                    status: :error,
+                    attempts: attempts,
+                    last_output: output,
+                    error_message: pending_candidate[:error_message] ||
+                      Hive::ClaudeCompletionFallback::STOP_HOOK_ERROR_MESSAGE,
+                    limit_text: pending_candidate[:limit_text]
+                  )
+                end
+              end
+              return Result.new(
+                status: :green,
+                attempts: attempts,
+                last_output: output,
+                error_message: nil,
+                limit_text: nil
+              )
+            end
+
+            pending_candidate = nil
 
             if attempts >= max_attempts
               return Result.new(
@@ -135,6 +186,19 @@ module Hive
               )
             end
 
+            if Hive::ClaudeCompletionFallback.completion_candidate?(spawn_result)
+              git_state = candidate_worktree_state(ctx.worktree_path)
+              unless git_state[:state] == :clean
+                return candidate_worktree_error(
+                  git_state, attempts: attempts, output: output,
+                  limit_text: spawn_result[:limit_text]
+                )
+              end
+              # Hold the candidate until the next CI iteration is green.
+              pending_candidate = spawn_result
+              next
+            end
+
             if spawn_result[:status] != :ok
               return Result.new(
                 status: :error,
@@ -328,6 +392,48 @@ module Hive
           status.success? && !out.empty?
         end
 
+        def candidate_worktree_state(path)
+          inside, rev_err, rev_status = Open3.capture3(
+            "git", "-C", path, "rev-parse", "--is-inside-work-tree"
+          )
+          unless rev_status.success? && inside.strip == "true"
+            return {
+              state: :unreadable,
+              error: "git rev-parse failed: #{rev_err.to_s.strip}"
+            }
+          end
+
+          status_out, status_err, status = Open3.capture3(
+            "git", "-C", path, "status", "--porcelain"
+          )
+          unless status.success?
+            return {
+              state: :unreadable,
+              error: "git status failed: #{status_err.to_s.strip}"
+            }
+          end
+
+          { state: status_out.empty? ? :clean : :dirty, error: nil }
+        rescue SystemCallError, IOError => e
+          { state: :unreadable, error: "git state unreadable: #{e.class}: #{e.message}" }
+        end
+
+        def candidate_worktree_error(git_state, attempts:, output:, limit_text:)
+          message =
+            if git_state[:state] == :dirty
+              "ci fix agent left uncommitted worktree changes"
+            else
+              "ci fix agent worktree state unreadable: #{git_state[:error]}"
+            end
+          Result.new(
+            status: :error,
+            attempts: attempts,
+            last_output: output,
+            error_message: message,
+            limit_text: limit_text
+          )
+        end
+
         def spawn_fix_agent(cfg:, ctx:, command:, attempt:, max_attempts:, captured_output:)
           profile_name = cfg.dig("review", "ci", "agent") || "claude"
           profile = Hive::AgentProfiles.lookup(profile_name, cfg: cfg)
diff --git a/lib/hive/stages/review/orchestrator_owned.rb b/lib/hive/stages/review/orchestrator_owned.rb
index 50cceca9..a87d0784 100644
--- a/lib/hive/stages/review/orchestrator_owned.rb
+++ b/lib/hive/stages/review/orchestrator_owned.rb
@@ -23,6 +23,7 @@ module Hive
         browser-
         fix-guardrail-
         fix-success-
+        fix-no-change-
         errors-
         suppressed.
       ].freeze
diff --git a/lib/hive/stages/review/triage.rb b/lib/hive/stages/review/triage.rb
index c2b624e1..dd660d58 100644
--- a/lib/hive/stages/review/triage.rb
+++ b/lib/hive/stages/review/triage.rb
@@ -1,6 +1,7 @@
 require "digest"
 require "fileutils"
 require "hive/agent_profiles"
+require "hive/claude_completion_fallback"
 require "hive/claude_launcher"
 require "hive/protected_files"
 require "hive/reviewers/plan_context"
@@ -33,6 +34,8 @@ module Hive
       # REVIEW_ERROR marker.
       module Triage
         Result = Data.define(:status, :escalations_path, :error_message, :tampered_files, :limit_text)
+        ESCALATION_Q_RE = /^\s*###\s+Q(\d+)\.\s*(.*?)\s*$/.freeze
+        ESCALATION_A_RE = /^\s*###\s+A(\d+)\.\s*$/.freeze
 
         # Files the triage agent must NOT modify. The reviewer files
         # are deliberately NOT in this list — triage's job is to edit
@@ -131,6 +134,10 @@ module Hive
             )
           end
 
+          spawn_result = promote_triage_completion_candidate!(
+            spawn_result, task: task, ctx: ctx, escalations: escalations
+          )
+
           if spawn_result[:status] == :ok
             Result.new(
               status: :ok,
@@ -155,6 +162,99 @@ module Hive
           end
         end
 
+        # Provisional missing-signal completion requires an escalations
+        # artifact that passes the same Q&A parser used by the orchestrator.
+        def promote_triage_completion_candidate!(spawn_result, task:, ctx:, escalations:)
+          return spawn_result unless Hive::ClaudeCompletionFallback.completion_candidate?(spawn_result)
+
+          unless valid_escalations_file?(ctx, escalations)
+            return spawn_result.merge(
+              status: :timeout,
+              error_message: spawn_result[:error_message] ||
+                Hive::ClaudeCompletionFallback::STOP_HOOK_ERROR_MESSAGE
+            )
+          end
+
+          decision = Hive::Stages::Base.accept_claude_completion_fallback(
+            task: task,
+            stage: "6-review",
+            agent: "phase=triage pass=#{format('%02d', ctx.pass)}",
+            candidate: spawn_result,
+            evidence: {
+              required_facts: %i[artifacts_present missing_output_absent],
+              artifacts_present: true,
+              missing_output_absent: true
+            },
+            audit_fields: {
+              phase: "triage",
+              pass: format("%02d", ctx.pass),
+              outcome: "fallback_accepted",
+              task_slug: File.basename(ctx.task_folder.to_s),
+              artifacts_checked: File.basename(escalations),
+              commit_evidence: "n/a"
+            }
+          )
+          return spawn_result.merge(status: :ok) if decision[:accepted]
+
+          spawn_result.merge(
+            status: :timeout,
+            error_message: spawn_result[:error_message] ||
+              Hive::ClaudeCompletionFallback::STOP_HOOK_ERROR_MESSAGE
+          )
+        end
+
+        def valid_escalations_file?(ctx, path)
+          return false unless File.exist?(path) && File.size(path).positive?
+
+          lines = File.readlines(path)
+          expected_header = "# Escalations for pass #{format('%02d', ctx.pass)}"
+          return false unless lines.first.to_s.strip == expected_header
+
+          questions = parse_escalation_questions(path)
+          question_ids = lines.filter_map { |line| ESCALATION_Q_RE.match(line)&.[](1)&.to_i }
+          answer_ids = lines.filter_map { |line| ESCALATION_A_RE.match(line)&.[](1)&.to_i }
+          if question_ids.empty?
+            return answer_ids.empty? && lines.drop(1).any? { |line| !line.strip.empty? }
+          end
+
+          question_ids == (1..question_ids.length).to_a &&
+            question_ids == questions.map { |question| question[:number] } &&
+            answer_ids == question_ids &&
+            questions.all? { |question| !question[:question].to_s.strip.empty? }
+        rescue SystemCallError, IOError
+          false
+        end
+
+        def parse_escalation_questions(path)
+          return [] unless File.exist?(path)
+
+          questions = []
+          current = nil
+          mode = nil
+
+          File.readlines(path).each do |line|
+            if (match = ESCALATION_Q_RE.match(line))
+              questions << current if current
+              current = {
+                number: match[1].to_i,
+                question: match[2].strip,
+                body: +"",
+                answer: +""
+              }
+              mode = :body
+            elsif current && (match = ESCALATION_A_RE.match(line)) && match[1].to_i == current[:number]
+              mode = :answer
+            elsif current && mode
+              current[mode] << line
+            end
+          end
+
+          questions << current if current
+          questions
+        rescue SystemCallError, IOError
+          []
+        end
+
         # Best-effort delete of a partial escalations file written by a
         # crashed triage agent. Errno::ENOENT is the no-op case (file
         # never existed); other I/O failures are intentionally swallowed
